# coding: utf-8

"""
    Restricted Assets

    Restricted assets serve as a safeguard and are used prevent assets from being traded in Aladdin. The Restricted Assets API can be used to list, create, update, upsert, filter and terminated restricted assets.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from asdk_plugin_portfolio.agraph.portfolio.configuration.restricted_asset.v1.RestrictedAssetAPI.models.v1_restricted_asset_query import V1RestrictedAssetQuery

class V1FilterRestrictedAssetsRequest(BaseModel):
    """
    V1FilterRestrictedAssetsRequest
    """
    query: Optional[V1RestrictedAssetQuery] = None
    page_token: Optional[StrictStr] = Field(None, alias="pageToken", description="A page token, received from a previous 'FilterRestrictedAssets' call. Provide this to retrieve the subsequent page.  When paginating, all other parameters provided to 'FilterRestrictedAssets' must match the call that provided the page token.")
    page_size: Optional[StrictInt] = Field(None, alias="pageSize", description="The maximum number of Restricted Asset to return. The service may return fewer than this value. If unspecified, at most 10000 Restricted Assets will be returned. The maximum value is 10000; values above 10000 will be rejected and exception will be thrown.")
    __properties = ["query", "pageToken", "pageSize"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterRestrictedAssetsRequest:
        """Create an instance of V1FilterRestrictedAssetsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of query
        if self.query:
            _dict['query'] = self.query.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterRestrictedAssetsRequest:
        """Create an instance of V1FilterRestrictedAssetsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterRestrictedAssetsRequest.parse_obj(obj)

        _obj = V1FilterRestrictedAssetsRequest.parse_obj({
            "query": V1RestrictedAssetQuery.from_dict(obj.get("query")) if obj.get("query") is not None else None,
            "page_token": obj.get("pageToken"),
            "page_size": obj.get("pageSize")
        })
        return _obj

