# coding: utf-8

"""
    Restricted Assets

    Restricted assets serve as a safeguard and are used prevent assets from being traded in Aladdin. The Restricted Assets API can be used to list, create, update, upsert, filter and terminated restricted assets.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from asdk_plugin_portfolio.agraph.portfolio.configuration.restricted_asset.v1.RestrictedAssetAPI.models.v1_restricted_asset import V1RestrictedAsset

class V1UpdateRestrictedAssetRequest(BaseModel):
    """
    V1UpdateRestrictedAssetRequest
    """
    restricted_asset: Optional[V1RestrictedAsset] = Field(None, alias="restrictedAsset")
    update_mask: Optional[StrictStr] = Field(None, alias="updateMask")
    __properties = ["restrictedAsset", "updateMask"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1UpdateRestrictedAssetRequest:
        """Create an instance of V1UpdateRestrictedAssetRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of restricted_asset
        if self.restricted_asset:
            _dict['restrictedAsset'] = self.restricted_asset.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1UpdateRestrictedAssetRequest:
        """Create an instance of V1UpdateRestrictedAssetRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1UpdateRestrictedAssetRequest.parse_obj(obj)

        _obj = V1UpdateRestrictedAssetRequest.parse_obj({
            "restricted_asset": V1RestrictedAsset.from_dict(obj.get("restrictedAsset")) if obj.get("restrictedAsset") is not None else None,
            "update_mask": obj.get("updateMask")
        })
        return _obj

